#include "card.h"
#include "cardfile.h"
#include "fileio.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *open_file (char **argv);
void print_card (struct card *card);

int main (int argc, char *argv[])
{
    FILE *f;
    struct card *cards;

    f = open_file (argv);
    cards = read_cardfile (f);
    fclose (f);

    while (cards)
    {
        print_card (cards);
        cards = cards->next;
    }

    delete_cardfile (cards);

    return 0;
}

FILE *open_file (char **argv)
{
    FILE *f;

    if (argv[1] == NULL)
    {
        printf ("Must specify cardfile.\n");
        printf ("Syntax: %s <cardfile>", argv[0]);
        exit (1);
    }

    if ((f = fopen (argv[1], "rb")) == NULL)
    {
        printf ("Cardfile %s not found.\n", argv[1]);
        exit (1);
    }

    return f;
}

void print_card (struct card *card)
{
    int i, row, text_length;

    char text_buffer[BODY_WIDTH];

    for (i = 0; i < card->title->length; i++)
        putchar (card->title->string[i]);
    putchar ('\n');

    for (i = 0; i < TITLE_WIDTH; i++)
        putchar ('-');
    putchar ('\n');

    for (row = 0; ; row++)
    {
    	if (! get_row (card, text_buffer, &text_length, row))
    		break;
        for (i = 0; i < text_length; i++)
            putchar (text_buffer[i]);
        putchar ('\n');
    }

    putchar ('\n');
}

